diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
index 4a6dfa0e1..df1117655 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
@@ -42,4 +42,10 @@ public class MobRendererChicken extends MobRenderer<MobChicken> {
         final float flapSpeed = MathHelper.lerp(entity.oFlapSpeed, entity.flapSpeed, partialTick);
         return (MathHelper.sin(flap) + 1.0F) * flapSpeed;
     }
+
+    @Override
+    protected void preRenderTransform(@NotNull MobChicken entity, double x, double y, double z, float yaw, float partialTick) {
+        super.preRenderTransform(entity, x, y, z, yaw, partialTick);
+        GL11.glTranslatef(0, 0.3f, 0);
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index 5974a14e2..8155d2e83 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -509,9 +509,9 @@ public class FontRendererDefault extends FontRenderer {
             }
 
             if (currLineWidth + currWordWidth + charWidth > maxWidth) { //
-                if (c == ' ') {
+                /*if (c == ' ') {
                     splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder);
-                } else {
+                } else */{
                     splitLineIntoConstrainedLine_wordBuilder.append(c);
                     currWordWidth += charWidth;
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
index ae24d5098..308593ce1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
@@ -74,11 +74,12 @@ public class Texture {
 		glBindTexture(GL_TEXTURE_2D, 0);
 	}
 
-	@Override
-	protected void finalize() throws Throwable {
-		super.finalize();
-		delete();
-	}
+	// TODO we CANNOT rely on this, especially as thing become more multithreaded this just destroys the game
+//	@Override
+//	protected void finalize() throws Throwable {
+//		super.finalize();
+//		delete();
+//	}
 
 	public boolean isGenerated() {
 		return id != 0;
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
index 5b0931dab..88be83130 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
@@ -10,7 +10,6 @@ import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.io.File;
-import java.io.FileOutputStream;
 import java.io.FileWriter;
 import java.io.IOException;
 import java.net.URI;
@@ -22,8 +21,6 @@ import java.nio.file.Path;
 import java.nio.file.Paths;
 import java.text.DateFormat;
 import java.text.SimpleDateFormat;
-import java.time.format.DateTimeFormatter;
-import java.time.format.DateTimeFormatterBuilder;
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.Date;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index de389dd89..8a5bad614 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -5,6 +5,7 @@ import java.util.Random;
 
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -1190,7 +1191,7 @@ public abstract class Entity
 
     public float getShadowHeightOffs()
     {
-        return bbHeight / 2.0F;
+        return 0.25f;
     }
 
     public @NotNull EntityItem dropItem(int itemId, int stackSize)
@@ -1268,7 +1269,7 @@ public abstract class Entity
 
         entityRiderYawDelta -= yaw;
         //entityRiderPitchDelta -= pitch;
-        if(turnWithVehicle) yRot += yaw;
+        if(turnWithVehicle && !(vehicle instanceof MobPig)) yRot += yaw;
         //rotationPitch += pitch;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 5942b6401..8e503d3bd 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -1227,7 +1227,7 @@ public abstract class Mob extends Entity
 
     public Vec3 getPosition(float partialTick, boolean headOffset)
     {
-        if(partialTick == 1.0F)
+        if(partialTick == 1.0F || isRemoved())
         {
             return Vec3.fromPool(x, y + (headOffset ? getHeadHeight() : 0), z);
         } else
@@ -1242,7 +1242,7 @@ public abstract class Mob extends Entity
     @Override
 	public Vec3 getViewVector(float partialTick)
     {
-        if(partialTick == 1.0F)
+        if(partialTick == 1.0F || isRemoved())
         {
             float z = MathHelper.cos(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
             float x = MathHelper.sin(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index 0ecda8f7f..68de88aa9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -85,8 +85,20 @@ public class MobPig
             final float accel = MathHelper.lerp(3, 10f, speedProgress) * (!onGround ? 0.25f : 1f) * (isInWater() ? 0.5f : 1f);
             final float maxSpeed = MathHelper.lerp(3, 10f, speedProgress) * (!(onGround || yd < 0) ? 0.25f : 1f) * (isInWater() ? 0.5f : 1f);
 
-            final double pXd = MathHelper.clamp(passenger.xd, -0.02, 0.02);
-            final double pZd = MathHelper.clamp(passenger.zd, -0.02, 0.02);
+            double pXd = passenger.xd;
+            double pZd = passenger.zd;
+
+            double vel = Math.sqrt(passenger.xd * passenger.xd + passenger.zd * passenger.zd);
+
+            if (vel != 0 && Double.isFinite(vel)) {
+                pXd /= vel;
+                pZd /= vel;
+
+                vel = MathHelper.clamp(vel, -0.02, 0.02);
+
+                pXd *= vel;
+                pZd *= vel;
+            }
 
             this.xd += pXd * accel;
             this.zd += pZd * accel;
diff --git a/game/core/src/main/java/net/minecraft/core/net/ServerAddress.java b/game/core/src/main/java/net/minecraft/core/net/ServerAddress.java
index df4a0c685..d9edc47a2 100644
--- a/game/core/src/main/java/net/minecraft/core/net/ServerAddress.java
+++ b/game/core/src/main/java/net/minecraft/core/net/ServerAddress.java
@@ -1,19 +1,22 @@
 package net.minecraft.core.net;
 
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
 import javax.naming.directory.Attributes;
 import javax.naming.directory.InitialDirContext;
 import java.util.Hashtable;
 
-public class ServerAddress {
-    private final String ipAddress;
+public final class ServerAddress {
+    private final @NotNull String ipAddress;
     private final int serverPort;
 
-    private ServerAddress(String ip, int port) {
+    private ServerAddress(@NotNull String ip, int port) {
         this.ipAddress = ip;
         this.serverPort = port;
     }
 
-    public String getIP() {
+    public @NotNull String getIP() {
         return this.ipAddress;
     }
 
@@ -21,7 +24,7 @@ public class ServerAddress {
         return this.serverPort;
     }
 
-    public static ServerAddress resolveServerIP(String ipToResolve) {
+    public static @Nullable ServerAddress resolveServerIP(@Nullable String ipToResolve) {
         if (ipToResolve == null) {
             return null;
         } else {
@@ -31,7 +34,7 @@ public class ServerAddress {
                 if (ipv6End > 0) {
                     String ipv6IP = ipToResolve.substring(1, ipv6End);
                     String port = ipToResolve.substring(ipv6End + 1).trim();
-                    if (port.startsWith(":") && !port.isEmpty()) {
+                    if (port.startsWith(":")) {
                         port = port.substring(1);
                         ipSplit = new String[]{ipv6IP, port};
                     } else {
@@ -77,4 +80,24 @@ public class ServerAddress {
             return defaultVal;
         }
     }
+
+    @Override
+    public String toString() {
+        return ipAddress + ":" + serverPort;
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (o == null || getClass() != o.getClass()) return false;
+
+        ServerAddress address = (ServerAddress) o;
+        return serverPort == address.serverPort && ipAddress.equals(address.ipAddress);
+    }
+
+    @Override
+    public int hashCode() {
+        int result = ipAddress.hashCode();
+        result = 31 * result + serverPort;
+        return result;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
index 8c625f5fb..13864118b 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
@@ -8,6 +8,7 @@ import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.CommandManager;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.net.command.CommandSource;
@@ -15,6 +16,8 @@ import net.minecraft.core.net.command.arguments.ArgumentTypeBiome;
 import net.minecraft.core.net.command.arguments.ArgumentTypeIntegerCoordinates;
 import net.minecraft.core.net.command.helpers.Coordinates2D;
 import net.minecraft.core.net.command.helpers.IntegerCoordinates;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkSection;
 
 public class CommandBiome implements CommandManager.CommandRegistry {
     private static final DynamicCommandExceptionType FAILURE = new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.biome.locate.exception_failure", arg));
@@ -22,6 +25,20 @@ public class CommandBiome implements CommandManager.CommandRegistry {
     public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(ArgumentBuilderLiteral.<CommandSource>literal("biome")
                 .requires(CommandSource::hasAdmin)
+                .then(ArgumentBuilderLiteral.<CommandSource>literal("set")
+                    .then(ArgumentBuilderRequired.<CommandSource, Biome>argument("biome", ArgumentTypeBiome.biome())
+                        .executes(c -> {
+                            Biome biome = c.getArgument("biome", Biome.class);
+                            c.getSource().sendMessage(biome.translationKey);
+                            Vec3 coords = c.getSource().getCoordinates(false);
+                            if (coords != null) {
+                                Chunk chunk = c.getSource().getWorld().getChunkFromBlockCoords(MathHelper.floor(coords.x), MathHelper.floor(coords.z));
+                                for (int s = 0; s < Chunk.CHUNK_SECTIONS; s++) {
+                                    chunk.getSection(s).setSectionBiome(biome);
+                                }
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        })))
                 .then(ArgumentBuilderLiteral.<CommandSource>literal("get")
                         .then(ArgumentBuilderRequired.<CommandSource, IntegerCoordinates>argument("position", ArgumentTypeIntegerCoordinates.intCoordinates())
                                 .executes(c -> {
diff --git a/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java b/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
index 95cde2c70..6774629b4 100644
--- a/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
@@ -393,4 +393,8 @@ public abstract class PacketHandler
     public void handleRequestCommandManagerPacket(PacketRequestCommandManager requestCommandManagerPacket) {
         handleInvalidPacket(requestCommandManagerPacket);
     }
+
+    public void handleServerIconPacket(PacketServerIcon packetServerIcon) {
+        handleInvalidPacket(packetServerIcon);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
index d2f511dd4..1a9437e9a 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -338,6 +338,7 @@ public abstract class Packet
         addMapping(200, true, false, PacketStatistic.class);
         addMapping(201, true, false, PacketSyncIDs.class);
         addMapping(250, true, true, PacketCustomPayload.class);
+        addMapping(253, true, false, PacketServerIcon.class);
         addMapping(254, false, true, PacketPingHandshake.class);
         addMapping(255, true, true, PacketDisconnect.class);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketPingHandshake.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketPingHandshake.java
index f56fd78d2..40f2a1876 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketPingHandshake.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketPingHandshake.java
@@ -9,8 +9,6 @@ import java.nio.charset.StandardCharsets;
 
 public class PacketPingHandshake
     extends Packet {
-    public static long startTime = 0;
-
     public int payload;
     public int identifier;
     public String pingHostString;
@@ -50,7 +48,6 @@ public class PacketPingHandshake
         dos.writeByte(protocolVersion);
         writeStringUTF16BE(hostname, dos);
         dos.writeInt(port);
-        startTime = System.currentTimeMillis();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketServerIcon.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketServerIcon.java
new file mode 100644
index 000000000..c9a23364d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketServerIcon.java
@@ -0,0 +1,41 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+import org.jetbrains.annotations.NotNull;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class PacketServerIcon extends Packet {
+    public byte[] image;
+    public PacketServerIcon() {
+
+    }
+
+    public PacketServerIcon(byte @NotNull [] image) {
+        this.image = image;
+    }
+
+    @Override
+    public void read(DataInputStream dis) throws IOException {
+        image = new byte[dis.readInt()];
+        dis.read(image);
+    }
+
+    @Override
+    public void write(DataOutputStream dos) throws IOException {
+        dos.writeInt(image.length);
+        dos.write(image);
+    }
+
+    @Override
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handleServerIconPacket(this);
+    }
+
+    @Override
+    public int getEstimatedSize() {
+        return image.length + 4;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 6a9ce7265..e0f5fe519 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -291,7 +291,7 @@ public class Chunk
         }
 
         section.setBlockId(tilePos.toChunkSectionTilePos(), id);
-        section.setData(tilePos.toChunkSectionTilePos(), id);
+        section.setData(tilePos.toChunkSectionTilePos(), data);
 
         final @NotNull TilePos worldPos = new TilePos(this.pos, tilePos);
         if (!raw && currentBlock != null && !this.world.isClientSide) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
index ca300f887..59e047386 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
@@ -137,11 +137,16 @@ public class ChunkSection {
         return this.getBiome(new ChunkSectionTilePos(x, y, z));
     }
 
+
+    public void setSectionBiome(Biome biome) {
+        int biomeId = Registries.BIOMES.getNumericIdOfItem(biome);
+        Arrays.fill(this.biome, (byte) biomeId);
+    }
+
     public void setBiome(final @NotNull ChunkSectionTilePos sectionPos, final @NotNull Biome biome) {
         if (!sectionPos.inBounds()) {
             return;
         }
-
         final int biomeId = Registries.BIOMES.getNumericIdOfItem(biome);
         this.biome[makeBiomeIndex(sectionPos)] = (byte) biomeId;
     }
diff --git a/game/core/src/main/resources/lang/en_US/gui.lang b/game/core/src/main/resources/lang/en_US/gui.lang
index c11da97f7..4fa3f6de4 100644
--- a/game/core/src/main/resources/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/lang/en_US/gui.lang
@@ -67,7 +67,7 @@ gui.conflict_warning.label.body.4=To prevent level corruption, the current game
 gui.conflict_warning.button.back=Back to title screen
 
 gui.connect_failed.label.title=Failed to connect to the server
-gui.connect_failed.button.back=Back to title screen
+gui.connect_failed.button.back=Back to server browser
 
 gui.connect_to_ip.button.connect=Connect
 gui.connect_to_ip.button.cancel=Cancel
@@ -105,6 +105,12 @@ gui.world_settings.page.game_rules.button.off=OFF
 gui.world_settings.label.select_world_type=Select World Type
 gui.world_settings.label.world_type=World Type
 
+gui.select_server.page.internet.title=Internet
+gui.select_server.page.favorites.title=Favorites
+gui.select_server.page.history.title=History
+gui.select_server.page.lan.title=Local Network
+gui.select_server.page.direct_connect.title=Direct Connect
+
 gui.dispenser.label.dispenser=Dispenser
 gui.dispenser.label.inventory=Inventory
 
@@ -331,6 +337,24 @@ gui.select_server.button.show_ip.on=ON
 gui.select_server.button.show_ip.off=OFF
 gui.select_server.button.no_jce.warning=§l§eJCE Missing!
 
+gui.select_server.popup.add.prompt.name=Server Name:
+gui.select_server.popup.add.prompt.ip=IP Address:
+gui.select_server.popup.add.button.save=Save
+gui.select_server.popup.add.button.cancel=Cancel
+gui.select_server.popup.add.showip.on=Show IP: ON
+gui.select_server.popup.add.showip.off=Show IP: OFF
+
+gui.select_server.popup.edit.prompt.name=Server Name:
+gui.select_server.popup.edit.prompt.ip=IP Address:
+gui.select_server.popup.edit.button.save=Save
+gui.select_server.popup.edit.button.cancel=Cancel
+gui.select_server.popup.edit.showip.on=Show IP: ON
+gui.select_server.popup.edit.showip.off=Show IP: OFF
+
+gui.select_server.popup.direct.prompt.ip=IP Address:
+gui.select_server.popup.direct.button.connect=Connect
+gui.select_server.popup.direct.button.cancel=Cancel
+
 gui.select_world.label.title=Select World
 gui.select_world.label.world=World %s
 gui.select_world.label.must_be_converted=Must be converted!
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index 9ec8e158f..c2a7a3597 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -58,6 +58,7 @@ import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.util.pool.ObjectPool;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.server.entity.player.PlayerServer;
+import net.minecraft.server.net.MulticastPublisher;
 import net.minecraft.server.net.command.ConsoleCommandSource;
 import net.minecraft.core.net.packet.PacketSetTime;
 import net.minecraft.core.player.gamemode.Gamemode;
@@ -112,9 +113,11 @@ import org.slf4j.Logger;
 import java.io.BufferedReader;
 import java.io.File;
 import java.io.IOException;
+import java.io.InputStream;
 import java.io.InputStreamReader;
 import java.net.InetAddress;
 import java.net.UnknownHostException;
+import java.nio.file.Files;
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.List;
@@ -132,6 +135,7 @@ public class MinecraftServer
 
     public @Nullable Boolean argOffline = null;
     public @Nullable String argWorld = null;
+    public int argPort = -1;
 
     public NetworkListenThread networkServer;
     public PropertyManager propertyManager;
@@ -146,6 +150,7 @@ public class MinecraftServer
     private final List<ServerCommandEntry> commands;
     public Int2ObjectMap<EntityTrackerImpl> entityTrackerMap;
     public boolean onlineMode;
+    public boolean broadcastPlayerList;
     public boolean pvpOn;
     public boolean allowFlight;
     public int spawnProtectionRange;
@@ -160,11 +165,15 @@ public class MinecraftServer
     public static String statsToken;
     public static boolean statsStatus;
     public boolean disablePhotoMode = false;
+    public String name = "";
     public String motd = "";
     private final SkinVariantList skinVariantList = new ServerSkinVariantList();
     public int autoSaveInterval = 5;
     public int chunksSavedPerAutosave = 24;
     public boolean forceSaveAllChunksOnAutosave = false;
+    public byte @Nullable [] iconBytes = null;
+    public final MulticastPublisher multicastPublisher = new MulticastPublisher();
+    public int ticksSinceLastBroadcast = 0;
 
     private boolean spawnAnimals;
     private boolean spawnHostiles;
@@ -219,6 +228,18 @@ public class MinecraftServer
             LOGGER.warn("To start the server with more ram, launch it as \"java -Xmx1024M -Xms1024M -jar minecraft_server.jar\"");
         }
 
+        File icon = new File("icon.png");
+        if (icon.exists()) {
+            try(InputStream stream = Files.newInputStream(new File("icon.png").toPath())) {
+                iconBytes = new byte[stream.available()];
+                for (int i = 0; i < iconBytes.length; i++) {
+                    iconBytes[i] = (byte) stream.read();
+                }
+            } catch (Exception e) {
+                LOGGER.error("", e);
+            }
+        }
+
         // Manually initialize blocks and items
         Blocks.init();
         Items.init();
@@ -232,6 +253,7 @@ public class MinecraftServer
         propertyManager = new PropertyManager(new File("server.properties"));
         String s = propertyManager.getStringProperty("server-ip", "");
         onlineMode = argOffline == null ? propertyManager.getBooleanProperty("online-mode", true) : !argOffline;
+        broadcastPlayerList = propertyManager.getBooleanProperty("broadcast-player-list", true);
         spawnAnimals = propertyManager.getBooleanProperty("spawn-animals", true);
         spawnHostiles = propertyManager.getBooleanProperty("spawn-monsters", true);
         pvpOn = propertyManager.getBooleanProperty("pvp", true);
@@ -248,6 +270,7 @@ public class MinecraftServer
         maxPlayers = propertyManager.getIntProperty("max-players", 20);
         language = propertyManager.getStringProperty("language", "en_US");
         disablePhotoMode = propertyManager.getBooleanProperty("disable-photomode", false);
+        name = propertyManager.getStringProperty("name", "");
         motd = propertyManager.getStringProperty("motd", "A Better than Adventure! Server");
         autoSaveInterval = propertyManager.getIntProperty("autosaveInterval", 5);
         chunksSavedPerAutosave = propertyManager.getIntProperty("maxChunksSavedPerAutosave", 24);
@@ -343,11 +366,16 @@ public class MinecraftServer
         {
             inetaddress = InetAddress.getByName(s);
         }
-        int i = propertyManager.getIntProperty("server-port", 25565);
-        LOGGER.info("Starting Minecraft server on " + (!s.isEmpty() ? s : "*") + ":" + i);
+        int port;
+        if (argPort >= 0) {
+            port = argPort;
+        } else {
+            port = propertyManager.getIntProperty("server-port", 25565);
+        }
+        LOGGER.info("Starting Minecraft server on {}:{}", !s.isEmpty() ? s : "*", port);
         try
         {
-            networkServer = new NetworkListenThread(this, inetaddress, i);
+            networkServer = new NetworkListenThread(this, inetaddress, port);
         }
         catch (IOException ioexception)
         {
@@ -787,6 +815,15 @@ public class MinecraftServer
         {
             LOGGER.warn( "Unexpected exception while parsing console command", exception);
         }
+
+        if (ticksSinceLastBroadcast++ >= 30) {
+            ticksSinceLastBroadcast = 0;
+            try {
+                multicastPublisher.multicast(String.format("[MOTD]%s[/MOTD][AD]%s[/AD][NAME]%s[/NAME]", motd, propertyManager.getIntProperty("server-port", 25565), name));
+            } catch (IOException e) {
+                LOGGER.error("", e);
+            }
+        }
     }
 
     public void addCommand(String s, ICommandListener icommandlistener)
@@ -821,6 +858,7 @@ public class MinecraftServer
         boolean nogui = false;
         Boolean offline = null;
         String world = null;
+        int port = -1;
 
         int pointer = 0;
         while (pointer < args.length) {
@@ -846,6 +884,14 @@ public class MinecraftServer
                     pointer++;
                     break;
                 }
+                case "--port": {
+                    try {
+                        port = Integer.parseInt(args[pointer + 1]);
+                        pointer++;
+                    } catch (final Exception e) {
+                        e.printStackTrace();
+                    }
+                }
                 default:
                     pointer++;
             }
@@ -857,6 +903,7 @@ public class MinecraftServer
 
             server.argOffline = offline;
             server.argWorld = world;
+            server.argPort = port;
 
             if (!nogui && !java.awt.GraphicsEnvironment.isHeadless())
             {
diff --git a/game/server/src/main/java/net/minecraft/server/net/MulticastPublisher.java b/game/server/src/main/java/net/minecraft/server/net/MulticastPublisher.java
new file mode 100644
index 000000000..b15f66ef9
--- /dev/null
+++ b/game/server/src/main/java/net/minecraft/server/net/MulticastPublisher.java
@@ -0,0 +1,24 @@
+package net.minecraft.server.net;
+
+import java.io.IOException;
+import java.net.DatagramPacket;
+import java.net.DatagramSocket;
+import java.net.InetAddress;
+import java.nio.charset.StandardCharsets;
+
+public class MulticastPublisher {
+    private DatagramSocket socket;
+    private InetAddress group;
+    private byte[] buf;
+
+    public void multicast(String multicastMessage) throws IOException {
+        socket = new DatagramSocket();
+        group = InetAddress.getByName("224.0.2.61");
+        buf = StandardCharsets.UTF_8.encode(multicastMessage).array();
+
+        DatagramPacket packet
+            = new DatagramPacket(buf, buf.length, group, 4445);
+        socket.send(packet);
+        socket.close();
+    }
+}
